// average.cpp: Uses function average to approximate an integral
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
using namespace std;

inline double f(double x) {
   return sin(x);
}

int main(int argc, char* argv[]) {
   // Set random number parms
   const double pi = 3.14159265358979323846;
   const double factor = pi/RAND_MAX;
   int n = 10000;
   if (argc > 1)
      n = atoi(argv[1]);
   srand(static_cast<unsigned int>(time(0)));

   // Compute average value
   int count = 0;
   for (int i = 0; i < n; ++i) {
      double x = rand()*factor;
      double y = double(rand())/RAND_MAX;
      if (y < f(x))
         ++count;
   }
   cout << pi * (count / double(n));
}

