// fsin.cpp: Calculates sin(x) as a float. x is
// reduced to the interval [-pi/2, pi/2]. Uses
// the first 6 non-zero terms of the Taylor's Series 
// (more would add nothing). Improvements still need
// to be made!
#include <iostream>
#include "../ieee.h"
using namespace std;

float pi = 3.14159265358979323846f;
float pi1 = 3.140625f;
float pi2 = 9.67653589793e-4f;
const int k = 6;

float mysine(float x) {
   int n = int(x/pi + 0.5*sign(x)); // Use double precision here
   x -= n*pi;
//   x -= n*pi1;
//   x -= n*pi2;
   float num = x;
   float den = 1.0f;
   float sum = x;
   int fact = 1;  // The denominator contains fact!

   for (int i = 0; i < k; ++i) {
      num = -num*x*x;
      den *= ++fact;
      den *= ++fact;
      sum += num/den;
   }
   return (n%2) ? -sum : sum;
}

int main() {
   cout << mysine(0.0f) << " (" << sin(0.0f) << ")\n";
   cout << mysine(pi/2.0f) << " (" << sin(pi/2.0f) << ")\n";
   cout << mysine(pi) << " (" << sin(pi) << ")\n";
   cout << mysine(3.0f*pi/2.0f) << " (" << sin(3.0f*pi/2.0f) << ")\n";
   cout << mysine(22.0f) << " (" << sin(22.0f) << ")\n";
   cout << mysine(10.0e8f) << " (" << sin(10.0e8f) << ")\n";
}

/* Output:
0 (0)
1 (1)
-0 (-8.74228e-08)
-1 (-1)
-0.00885069 (-0.0088513)
-0.854296 (0.545843)
*/
