// gaussian.cpp: Naive Gaussian Elimination

#include <iostream>
using namespace std;

void gauss(double a[][10], int n, double x[], double b[]) {

   // Forward Elimination:
   // k is the row a multiple of which we'll add to the rows below
   // i is the row we're replacing
   // j is the column position
   // We ignore the subdiagonal elements that become zero
   for (int k = 0; k < n-1; ++k)
      for (int i = k+1; i < n; ++i) {
         double factor = a[i][k] / a[k][k];
         for (int j = k+1;  j < n; ++j)
            a[i][j] -= factor*a[k][j];
         b[i] -= factor*b[k];
      }

   // Back substitution
   for (int i = n-1; i >= 0; --i) {
      double sum = 0.0;
      for (int j = i+1; j < n; ++j)
         sum += a[i][j]*x[j];
      x[i] = (b[i] - sum) / a[i][i];
   }
}

int main() {
   double a[][10] = {{10.0, -7.0, 0.0},{-3.0,2.0,6.0},{5.0,-1.0,5.0}};
   double x[3], b[3] = {7.0, 4.0, 6.0};
   gauss(a,3,x,b);
   for (int i = 0; i < 3; ++i)
      cout << x[i] << endl;
}

/* Output:
1.95399e-15
-1
1
*/
