#include <cmath>
#include <iostream>
#include <limits>
#include <typeinfo>
using namespace std;

int main() {
   cout.setf(ios::boolalpha);
   int radix = numeric_limits<double>::radix;
   int digits = numeric_limits<double>::digits;
   cout << numeric_limits<double>::radix << endl;
   cout << numeric_limits<double>::digits << endl;
   cout << numeric_limits<double>::min_exponent << endl;
   cout << numeric_limits<double>::max_exponent << endl;
   cout << numeric_limits<double>::min() << endl;
   cout << numeric_limits<double>::denorm_min() << endl;
   cout << numeric_limits<double>::max() << endl;
   cout << numeric_limits<double>::epsilon() << endl;
   cout << pow(double(radix), 1-digits) << endl;
   cout << radix/2.0*pow(double(radix), -digits) << endl;
   if (numeric_limits<double>::has_infinity) {
      cout << numeric_limits<double>::infinity() << endl;
      cout << typeid(numeric_limits<double>::infinity()).name() << endl;
   }
   cout << numeric_limits<double>::round_style << endl;
   cout << numeric_limits<double>::round_error() << endl;
   cout << numeric_limits<double>::is_iec559 << endl;
#if defined(_MSC_VER) || defined(__EDG__)
   cout << numeric_limits<double>::has_quiet_NaN << endl;
   cout << numeric_limits<double>::quiet_NaN() << endl;
   cout << numeric_limits<double>::has_signaling_NaN << endl;
   cout << numeric_limits<double>::signaling_NaN() << endl;
   double nan = 0.0/0.0;
   cout << nan << endl;
   double qnan = numeric_limits<double>::quiet_NaN();
   cout << (nan == qnan) << endl;
#endif
}

/* Output:
2
53
-1021
1024
2.22507e-308
1.79769e+308
2.22045e-16
2.22045e-16
1.11022e-16
inf
double
1
0.5
true
*/
